	device zxspectrum128
;1997
entrya=$4000-256
	macro	sectors datab,datae
 IF low (datae-datab)=0
   db high (datae-datab)
 ELSE
   db (1+high (datae-datab))
 ENDIF

	endm

	org entrya-14*1-9
scl_b:
;header_b:
 db "SINCLAIR"
 db 1; filez
;-1st
;    12345678t
 db "Galx    B"
 dw basic_e-basic_b-4;start
 dw basic_e-basic_b-4;length?
 sectors basic_b,scl_e;sectors


 org entrya
basic_b:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 res 4,(iy+1)

 ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
 ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir

;-----------------
; di
; ld sp,$5FFF
; ld a,$10,bc,$7FFD:out (c),a
; ld hl,(23635)
; ld de,my_b-entrya
; add hl,de
; ld de,$5B00
; ld bc,my_e-my_b
; ldir
; call $5B00

 xor a:out ($FE),a
my_b:
; di
; jr $
 ld sp,$5FFF
 ld a,$10,bc,$7FFD:out (c),a
 ld de,(#5CF4)
 ld hl,26368
 ld bc,$0805
 call $3D13
 
; jr $
 call 26368
 jr $
;----------------------------------------------------
; patch for space
; jr $
; ld hl,(23635)
; ld de,patch-entrya
; add hl,de
;jpa equ $69EE
; ld a,$C3,(jpa),a,(jpa+1),hl
; jp $6978
;patch:
;; ld a,2:out ($FE),a
;; jr $
;; ld hl,0,($721c),hl,($72fe),hl
;; ld a,$18,($6Ed1),a,($6EDD),a; 6edd - C
;; ld hl,$fe18,($61b1),hl
;; ld hl,$3DAF,($63CC),hl
;; ld a,$C3,($621E),a
; ld hl,0,($621D),hl
; call $61A8
; jr $
my_e:
;------------------------------

 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
basic_e:

; align 256
; incbin "ldr.bin"
;
 align 256
 incbin "GALx.EXE.C"
;;
; align 256
; incbin "hf2.scr"
;
; align 256
; incbin "tu3.bin"

; align 256
; incbin "blo5dA2.bin"
;
; align 256
; incbin "blo7611.bin"

; align 256
; incbin "intro.bin"

; align 256
; incbin "load.bin"

; align 256
; incbin "ldr.bin"

; align 256
; incbin "data1.bin"
;
; align 256
; incbin "data2.bin"

; align 256
; incbin "data3.bin"
;
; align 256
; incbin "data4.bin"

; align 256
; incbin "data5.bin"

; align 256
; incbin "data6.bin"

scl_e:

	savebin "Galx.scl",scl_b,scl_e-scl_b

	LUA

	local fp
	local checksum
	
	fp = assert(io.open("Galx.scl", "rb"))
	checksum=0
	while true do
		local byte = fp:read(1)
		if byte==nil then
			break
		end
		checksum=checksum+string.byte(byte)
	end
	assert(fp:close())
	print("writing",string.format("%08X",checksum))
	fp = assert(io.open("Galx.scl", "a"))

	for i=1,4 do
    	fp:write(string.char(checksum%256))
    	checksum=math.floor(checksum/256)
    end

--	assert(fp:flush())
	assert(fp:close())
	ENDLUA

